;.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,
;                                                                       ;
;Copyright (c) 2002-2004 Jernej Simoncic                                ;
;                                                                       ;
;This software is provided 'as-is', without any express or implied      ;
;warranty. In no event will the authors be held liable for any damages  ;
;arising from the use of this software.                                 ;
;                                                                       ;
;Permission is granted to anyone to use this software for any purpose,  ;
;including commercial applications, and to alter it and redistribute it ;
;freely, subject to the following restrictions:                         ;
;                                                                       ;
;   1. The origin of this software must not be misrepresented; you must ;
;      not claim that you wrote the original software. If you use this  ;
;      software in a product, an acknowledgment in the product          ;
;      documentation would be appreciated but is not required.          ;
;                                                                       ;
;   2. Altered source versions must be plainly marked as such, and must ;
;      not be misrepresented as being the original software.            ;
;                                                                       ;
;   3. This notice may not be removed or altered from any source        ;
;      distribution.                                                    ;
;.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.,.;
;
;GTK+ 2.4 runtime environment setup script, for Inno Setup with ISPP
;
;extract all files needed by GTK+ 2 in a folder, keeping the structure and run the script from that
;folder
;put libwimp.dll and it's gtkrc in the wimp subfolder
;
;Made by Jernej Simoncic, <jernej.simoncic@guest.arnes.si>
;
;This script hasn't been tested much yet!
;
;Note: the GTK+ installation path is stored in Registry, in one of these keys (depends whether GTK+ 2
;was installed by administrator or normal user):
;  HKEY_LOCAL_MACHINE\SOFTWARE\Software\GTK\2.0\Path
;  HKEY_CURRENT_USER\SOFTWARE\Software\GTK\2.0\Path
;If none of these keys exist, you can assume that GTK+ 2 isn't installed.
;The Setup also stores GTK version in registry, in one of these keys:
;  HKEY_LOCAL_MACHINE\SOFTWARE\Software\GTK\2.0\Version
;  HKEY_CURRENT_USER\SOFTWARE\Software\GTK\2.0\Version
;
;changelog:
;20040330 - merged relevant changes from Gimp 2.0.0 setup (localization, component descriptions, RTF,
;           bad DLL detection & renaming)
;         - store library path in registry
;         - detect older GTK versions and try to uninstall them; if automatic uninstalling isn't
;           possible, die
;20040102 - gtk-wimp
;20031019 - minor fix in gtkrc generation (should only affect people who have different window text
;           and button text colors)
;         - add GTK+ install directory to PATH
;20031018 - save color scheme to default gtkrc
;20030905 - adapted the GTK+ 1.3 install script for GTK 2.2
;
;TODO:
;- version x.y.z-date should be considered newer than x.y.z-revision
;- CPU detection doesn't work on Win95 (should I really bother??)
;- stop checking PATH for GTK DLLs after GTK install dir
;- move all text to default.isl+
;- use IS 4.2.1+ native support for custom translation strings

;#pragma SingleQuotes(1)

;GTK+ version (should be in format v.v.v[-yyyymmdd][-x] - x is installer revision)
#define GTKVer='2.4.0'

;#define ext7z
;#define testing

[Setup]
AppName=GTK+ 2 runtime environment
AppID=WinGTK-2
AppVerName=GTK+ {#= GTKVer} runtime environment
AppPublisher=Tor Lillqvist
AppPublisherURL=http://www.gimp.org/win32/
AppSupportURL=http://www.gimp.org/win32/
;AppUpdatesURL=http://www2.arnes.si/~sopjsimo/gimp/test/
DisableProgramGroupPage=true
DefaultDirName={cf}\GTK\2.0
;AlwaysCreateUninstallIcon=true
LicenseFile=_install\libgpl.rtf
ChangesAssociations=true
WizardImageFile=_install\gtklogo.bmp
WizardSmallImageFile=_install\gtk_small.bmp
;CreateAppDir=no
#ifdef ext7z
OutputDir=Output\47z
UseSetupLdr=no
Compression=none
InternalCompressLevel=none
#else
OutputBaseFileName=gtk+-{#= GTKVer}-setup
Compression=lzma/ultra
SolidCompression=yes
InternalCompressLevel=ultra
#endif
;MinVersion=4,4
;required to update the PATH variable
;AlwaysRestart=true

[Types]
Name: full; Description: "{code:GetText|TypeFull}"
Name: compact; Description: "{code:GetText|TypeCompact}"
Name: custom; Description: "{code:GetText|TypeCustom}"; Flags: iscustom

;[Tasks]
;Name: gtkrc; Description: "Use current Windows color scheme for programs which use GTK+ 2"; GroupDescription: "Interface"

[Components]
Name: base; Description: "{code:GetText|ComponentsBase}"; Types: full compact custom; Flags: fixed
Name: theme; Description: "{code:GetText|ComponentsWimp}"; Types: full compact
Name: loc; Description: "{code:GetText|ComponentsTranslations}"; Types: full
#if 0
;TODO
Name: loc\az; Description: "Azerbaijani"; Types: full custom
Name: loc\ca; Description: "Catalan"; Types: full custom
Name: loc\de; Description: "German"; Types: full custom
Name: loc\eu; Description: "Basque"; Types: full custom
Name: loc\ga; Description: "Irish"; Types: full custom
Name: loc\hr; Description: "Croatian"; Types: full custom
Name: loc\ja; Description: "Japanese"; Types: full custom
Name: loc\lv; Description: "Latvian"; Types: full custom
Name: loc\ms; Description: "Malay"; Types: full custom
Name: loc\pl; Description: "Polish"; Types: full custom
Name: loc\ru; Description: "Russian"; Types: full custom
Name: loc\sr; Description: "Serbian"; Types: full custom
Name: loc\tr; Description: "Turkish"; Types: full custom
Name: loc\yi; Description: "Yiddish"; Types: full custom
Name: loc\be; Description: "Belarusian"; Types: full custom
Name: loc\cs; Description: "Czech"; Types: full custom
Name: loc\el; Description: "Greek"; Types: full custom
Name: loc\fa; Description: "Persian"; Types: full custom
Name: loc\gl; Description: "Gallegan"; Types: full custom
Name: loc\hu; Description: "Hungarian"; Types: full custom
Name: loc\ko; Description: "Korean"; Types: full custom
Name: loc\mk; Description: "Macedonian"; Types: full custom
Name: loc\nl; Description: "Dutch"; Types: full custom
Name: loc\pt; Description: "Portuguese"; Types: full custom
Name: loc\sk; Description: "Slovak"; Types: full custom
Name: loc\sr@Latn; Description: "Serbian (Latin)"; Types: full custom
Name: loc\uk; Description: "Ukrainian"; Types: full custom
Name: loc\zh_CN; Description: "Chinese (Simplified)"; Types: full custom
Name: loc\zh_TW; Description: "Chinese (Traditional)"; Types: full custom
Name: loc\am; Description: "Amharic"; Types: full custom
Name: loc\bg; Description: "Bulgarian"; Types: full custom
Name: loc\cy; Description: "Welsh"; Types: full custom
Name: loc\es; Description: "Spanish"; Types: full custom
Name: loc\fi; Description: "Finnish"; Types: full custom
Name: loc\he; Description: "Hebrew"; Types: full custom
Name: loc\id; Description: "Indonesian"; Types: full custom
Name: loc\li; Description: "Limburgish"; Types: full custom
Name: loc\ml; Description: "Malayalam"; Types: full custom
Name: loc\nn; Description: "Norwegian Nynorsk"; Types: full custom
Name: loc\pt_BR; Description: "Portuguese (Brazil)"; Types: full custom
Name: loc\sl; Description: "Slovenian"; Types: full custom
Name: loc\sv; Description: "Swedish"; Types: full custom
Name: loc\vi; Description: "Vietnamese"; Types: full custom
Name: loc\ar; Description: "Arabic"; Types: full custom
Name: loc\bn; Description: "Bengali"; Types: full custom
Name: loc\da; Description: "Danish"; Types: full custom
Name: loc\et; Description: "Estonian"; Types: full custom
Name: loc\fr; Description: "French"; Types: full custom
Name: loc\hi; Description: "Hindi"; Types: full custom
Name: loc\it; Description: "Italian"; Types: full custom
Name: loc\lt; Description: "Lithuanian"; Types: full custom
Name: loc\mn; Description: "Mongolian"; Types: full custom
Name: loc\no; Description: "Norwegian"; Types: full custom
Name: loc\ro; Description: "Romanian"; Types: full custom
Name: loc\sq; Description: "Albanian"; Types: full custom
Name: loc\ta; Description: "Tamil"; Types: full custom
Name: loc\wa; Description: "Walloon"; Types: full custom
#endif

[Files]
Source: "_install\setup.ini"; Flags: dontcopy
Source: "_install\*.isl+"; Flags: dontcopy
#ifndef testing
Source: "bin\*.*"; DestDir: "{code:GetGTKdir|nothing}\bin"; Flags: recursesubdirs comparetimestamp; Components: base

;Source: "bin\intl.dll"; DestDir: "{code:GetGTKdir|nothing}\bin"; DestName: "libintl-1.dll"; Components: base
;Source: "bin\zlib-1.dll"; DestDir: "{code:GetGTKdir|nothing}\bin"; DestName: "zlib.dll"; Components: base
;Source: "bin\jpeg-62.dll"; DestDir: "{code:GetGTKdir|nothing}\bin"; DestName: "libjpeg.dll"; Components: base
;Source: "bin\libpng12.dll"; DestDir: "{code:GetGTKdir|nothing}\bin"; DestName: "libpng.dll"; Components: base
Source: "bin\jpeg62.dll"; DestDir: "{code:GetGTKdir|nothing}\bin"; DestName: "jpeg-62.dll"; Components: base
Source: "bin\zlib1.dll"; DestDir: "{code:GetGTKdir|nothing}\bin"; DestName: "zlib-1.dll"; Components: base
Source: "bin\freetype6.dll"; DestDir: "{code:GetGTKdir|nothing}\bin"; DestName: "freetype-6.dll"; Components: base

Source: "etc\*.*"; DestDir: "{code:GetGTKdir|nothing}\etc"; Flags: recursesubdirs; Components: base
Source: "share\*.*"; DestDir: "{code:GetGTKdir|nothing}\share"; Flags: recursesubdirs; Components: base
Source: "lib\gtk-2.0\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\gtk-2.0"; Flags: ignoreversion recursesubdirs; Components: base
Source: "lib\pango\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\pango"; Flags: ignoreversion recursesubdirs; Components: base

source: "wimp\gtkrc"; DestDir: "{code:GetGTKdir|nothing}\etc\gtk-2.0"; Flags: ignoreversion; Components: theme
source: "wimp\libwimp.dll"; DestDir: "{code:GetGTKdir|nothing}\lib\gtk-2.0\2.4.0\engines"; Components: theme

Source: "lib\locale\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale"; Flags: ignoreversion recursesubdirs; Components: loc
#if 0
;TODO
Source: "lib\locale\az\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\az"; Flags: ignoreversion recursesubdirs; Components: loc\az
Source: "lib\locale\ca\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ca"; Flags: ignoreversion recursesubdirs; Components: loc\ca
Source: "lib\locale\de\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\de"; Flags: ignoreversion recursesubdirs; Components: loc\de
Source: "lib\locale\eu\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\eu"; Flags: ignoreversion recursesubdirs; Components: loc\eu
Source: "lib\locale\ga\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ga"; Flags: ignoreversion recursesubdirs; Components: loc\ga
Source: "lib\locale\hr\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\hr"; Flags: ignoreversion recursesubdirs; Components: loc\hr
Source: "lib\locale\ja\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ja"; Flags: ignoreversion recursesubdirs; Components: loc\ja
Source: "lib\locale\lv\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\lv"; Flags: ignoreversion recursesubdirs; Components: loc\lv
Source: "lib\locale\ms\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ms"; Flags: ignoreversion recursesubdirs; Components: loc\ms
Source: "lib\locale\pl\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\pl"; Flags: ignoreversion recursesubdirs; Components: loc\pl
Source: "lib\locale\ru\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ru"; Flags: ignoreversion recursesubdirs; Components: loc\ru
Source: "lib\locale\sr\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sr"; Flags: ignoreversion recursesubdirs; Components: loc\sr
Source: "lib\locale\tr\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\tr"; Flags: ignoreversion recursesubdirs; Components: loc\tr
Source: "lib\locale\yi\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\yi"; Flags: ignoreversion recursesubdirs; Components: loc\yi
Source: "lib\locale\be\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\be"; Flags: ignoreversion recursesubdirs; Components: loc\be
Source: "lib\locale\cs\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\cs"; Flags: ignoreversion recursesubdirs; Components: loc\cs
Source: "lib\locale\el\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\el"; Flags: ignoreversion recursesubdirs; Components: loc\el
Source: "lib\locale\fa\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\fa"; Flags: ignoreversion recursesubdirs; Components: loc\fa
Source: "lib\locale\gl\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\gl"; Flags: ignoreversion recursesubdirs; Components: loc\gl
Source: "lib\locale\hu\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\hu"; Flags: ignoreversion recursesubdirs; Components: loc\hu
Source: "lib\locale\ko\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ko"; Flags: ignoreversion recursesubdirs; Components: loc\ko
Source: "lib\locale\mk\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\mk"; Flags: ignoreversion recursesubdirs; Components: loc\mk
Source: "lib\locale\nl\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\nl"; Flags: ignoreversion recursesubdirs; Components: loc\nl
Source: "lib\locale\pt\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\pt"; Flags: ignoreversion recursesubdirs; Components: loc\pt
Source: "lib\locale\sk\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sk"; Flags: ignoreversion recursesubdirs; Components: loc\sk
Source: "lib\locale\sr@Latn\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sr@Latn"; Flags: ignoreversion recursesubdirs; Components: loc\sr@Latn
Source: "lib\locale\uk\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\uk"; Flags: ignoreversion recursesubdirs; Components: loc\uk
Source: "lib\locale\zh_CN\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\zh_CN"; Flags: ignoreversion recursesubdirs; Components: loc\zh_CN
Source: "lib\locale\am\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\am"; Flags: ignoreversion recursesubdirs; Components: loc\am
Source: "lib\locale\bg\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\bg"; Flags: ignoreversion recursesubdirs; Components: loc\bg
Source: "lib\locale\cy\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\cy"; Flags: ignoreversion recursesubdirs; Components: loc\cy
Source: "lib\locale\es\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\es"; Flags: ignoreversion recursesubdirs; Components: loc\es
Source: "lib\locale\fi\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\fi"; Flags: ignoreversion recursesubdirs; Components: loc\fi
Source: "lib\locale\he\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\he"; Flags: ignoreversion recursesubdirs; Components: loc\he
Source: "lib\locale\id\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\id"; Flags: ignoreversion recursesubdirs; Components: loc\id
Source: "lib\locale\li\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\li"; Flags: ignoreversion recursesubdirs; Components: loc\li
Source: "lib\locale\ml\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ml"; Flags: ignoreversion recursesubdirs; Components: loc\ml
Source: "lib\locale\nn\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\nn"; Flags: ignoreversion recursesubdirs; Components: loc\nn
Source: "lib\locale\pt_BR\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\pt_BR"; Flags: ignoreversion recursesubdirs; Components: loc\pt_BR
Source: "lib\locale\sl\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sl"; Flags: ignoreversion recursesubdirs; Components: loc\sl
Source: "lib\locale\sv\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sv"; Flags: ignoreversion recursesubdirs; Components: loc\sv
Source: "lib\locale\vi\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\vi"; Flags: ignoreversion recursesubdirs; Components: loc\vi
Source: "lib\locale\zh_TW\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\zh_TW"; Flags: ignoreversion recursesubdirs; Components: loc\zh_TW
Source: "lib\locale\ar\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ar"; Flags: ignoreversion recursesubdirs; Components: loc\ar
Source: "lib\locale\bn\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\bn"; Flags: ignoreversion recursesubdirs; Components: loc\bn
Source: "lib\locale\da\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\da"; Flags: ignoreversion recursesubdirs; Components: loc\da
Source: "lib\locale\et\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\et"; Flags: ignoreversion recursesubdirs; Components: loc\et
Source: "lib\locale\fr\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\fr"; Flags: ignoreversion recursesubdirs; Components: loc\fr
Source: "lib\locale\hi\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\hi"; Flags: ignoreversion recursesubdirs; Components: loc\hi
Source: "lib\locale\it\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\it"; Flags: ignoreversion recursesubdirs; Components: loc\it
Source: "lib\locale\lt\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\lt"; Flags: ignoreversion recursesubdirs; Components: loc\lt
Source: "lib\locale\mn\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\mn"; Flags: ignoreversion recursesubdirs; Components: loc\mn
Source: "lib\locale\no\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\no"; Flags: ignoreversion recursesubdirs; Components: loc\no
Source: "lib\locale\ro\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ro"; Flags: ignoreversion recursesubdirs; Components: loc\ro
Source: "lib\locale\sq\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sq"; Flags: ignoreversion recursesubdirs; Components: loc\sq
Source: "lib\locale\ta\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ta"; Flags: ignoreversion recursesubdirs; Components: loc\ta
Source: "lib\locale\wa\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\wa"; Flags: ignoreversion recursesubdirs; Components: loc\wa
#endif
#endif

[Messages]
WelcomeLabel1=Welcome to Setup Wizard for GTK+ 2 runtime environment
AboutSetupNote=Setup script by Jernej Simoncic, jernej.simoncic@isg.si
SetupLdrStartupMessage=This program will install or update %1. Do you wish to continue?
ConfirmUninstall=This program will uninstall GTK+ 2 runtime environment, which may be needed by other programs. Are you sure you want the uninstall to proceed?

[Registry]
Root: "HKLM"; SubKey: "SOFTWARE\GTK\2.0"; ValueType: string; ValueName: "Path"; ValueData: "{code:GetGTKDir|none}"; Check: AdminCheck(yes); Flags: uninsdeletevalue uninsdeletekeyifempty
Root: "HKLM"; SubKey: "SOFTWARE\GTK\2.0"; ValueType: string; ValueName: "DllPath"; ValueData: "{code:GetGTKDir|none}"; Check: AdminCheck(yes); Flags: uninsdeletevalue uninsdeletekeyifempty
Root: "HKLM"; SubKey: "SOFTWARE\GTK\2.0"; ValueType: string; ValueName: "Version"; ValueData: "{#= GTKVer}"; Check: AdminCheck(yes); Flags: uninsdeletevalue uninsdeletekeyifempty
Root: "HKCU"; SubKey: "SOFTWARE\GTK\2.0"; ValueType: string; ValueName: "Path"; ValueData: "{code:GetGTKDir|none}"; Check: AdminCheck(no); Flags: uninsdeletevalue uninsdeletekeyifempty
Root: "HKCU"; SubKey: "SOFTWARE\GTK\2.0"; ValueType: string; ValueName: "DllPath"; ValueData: "{code:GetGTKDir|none}"; Check: AdminCheck(no); Flags: uninsdeletevalue uninsdeletekeyifempty
Root: "HKCU"; SubKey: "SOFTWARE\GTK\2.0"; ValueType: string; ValueName: "Version"; ValueData: "{#= GTKVer}"; Check: AdminCheck(no); Flags: uninsdeletevalue uninsdeletekeyifempty

Root: "HKLM"; SubKey: "SYSTEM\CurrentControlSet\Control\Session Manager\Environment"; ValueType: expandsz; ValueName: "Path"; ValueData: "{olddata};{code:GetGTKdir|nothing}\bin"; Flags: preservestringtype; Check: PrevPathCheck


[Code]
program Setup;

  type
  DWORD = Cardinal;
  TSystemInfo = record
    wProcessorArchitecture: Word;
    wReserved: Word;
    dwPageSize: DWORD;
    lpMinimumApplicationAddress: Integer;
    lpMaximumApplicationAddress: Integer;
    dwActiveProcessorMask: DWORD;
    dwNumberOfProcessors: DWORD;
    dwProcessorType: DWORD;
    dwAllocationGranularity: DWORD;
    wProcessorLevel: Word;
    wProcessorRevision: Word;
  end;

  function GetSysColor(nIndex: Integer): Integer; external 'GetSysColor@user32 stdcall';
	procedure GetSystemInfo(var lpSystemInfo: TSystemInfo); external 'GetSystemInfo@kernel32.dll stdcall';
	
	function TerminateProcess(hProcess, uExitCode: Cardinal): Cardinal; external'TerminateProcess@kernel32.dll stdcall';
  function GetWindowThreadProcessId(hwnd: Cardinal; var lpdwProcessId: Cardinal): Cardinal; external 'GetWindowThreadProcessId@user32.dll stdcall';
  function OpenProcess(dwDesiredAccess, bInheritHandle, dwProcessId: Cardinal): Cardinal; external 'OpenProcess@kernel32.dll stdcall';

  var
    GTKDir, OldGTKUninstall,OldGTKUninstallParams: String;
    DontChooseDir: Boolean;
    Warnings: Integer;
    InstPath,InstPathVal: TArrayOfString;
    ReadyMemoRichText: String;
    BadDLLs: TArrayOfString;
    BadDLLText: String;
    ShouldRenameBadDLLs: Integer;

    lblDescriptionText: TLabel;

  const
  	WM_QUIT = 18;
    STANDARD_RIGHTS_REQUIRED = $F0000;
    SYNCHRONIZE = $100000;
    PROCESS_ALL_ACCESS = STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or $FFF;

    GTKRegPath = 'SOFTWARE\GTK\2.0';
    OldGTKVersion = '2.4.0';
    UninstKey = 'UninstallString';
    //path to the uninstall information; you shouldn't change this
    UninstPath = 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\';
    //various GTK installer IDs, separated by "\"; do not add uninstallers which don't
    //support automatic/silent uninstalling
    GTKUninstKeys = 'GTK+ Runtime Environment_is1\WinGTK-2_is1';
    //parameters to run the uninstaller in automatic mode, in the same order as GTKUninstKeys
    GTKUninstParams = '/SILENT /NORESTART\/SILENT /NORESTART';

    //used for constructing rich text content
    RTFHeader = '{\rtf1\ansi\ansicpg1250\deff0\deflang1060{\fonttbl{\f0\fswiss\fprq2\fcharset238 Tahoma;}{\f1\fswiss\fprq2\fcharset0 Tahoma;}{\f2\fnil\fcharset2 Symbol;}}\viewkind4\uc1\pard{\*\pn\pnlvlblt\pnf2\pnindent0}\fi-284\li284\f0\fs16\sa60'#13#10;
    RTFHeaderM= '{\rtf1\deff0{\fonttbl{\f0\fswiss\fprq2\fcharset0 Tahoma;}}\viewkind4\uc1\fs16';
    RTFBullet = '{\pntext\f1\''B7\tab}';
    RTFPara   = '\par'#13#10;


  function Replace(SearchFor, ReplaceWith, Text: String): String;
  var t1,t2: String;
      i: Integer;
  begin
    i := 1;
    if (Length(SearchFor)> 0) and (Pos(SearchFor,Text)>0) then
    begin
      while i<Length(Text) do
      begin
        if Copy(Text,i,Length(SearchFor)) = SearchFor then
        begin
          t1 := Copy(Text,1,i-1);
          t2 := Copy(Text,i+Length(SearchFor),Length(Text));
          Text := t1 + ReplaceWith + t2;
          i := i + Length(ReplaceWith);
        end else
          i := i + 1;

      end;

    end;
    Result := Text;
  end;


	function Count(What, Where: String): Integer;
	begin
		Result := 0;
		if Length(What) = 0 then
			exit; //avoid infinite loop
		while Pos(What,Where)>0 do
		begin
			Where := Copy(Where,Pos(What,Where)+Length(What),Length(Where));
			Result := Result + 1;
		end;
	end;
	

	//split text to array
	procedure Explode(var Dest: TArrayOfString; Text, Separator: String);
	var tmp: Integer;
	begin
	  if Separator='' then
	    exit;
	
		SetArrayLength(Dest,Count(Separator,Text)+1)

	  tmp := 0;
    repeat
      if Pos(Separator,Text)>0 then
      begin
        Dest[tmp] := Copy(Text,1,Pos(Separator,Text)-1)
 			  Text := Copy(Text,Pos(Separator,Text)+Length(Separator),Length(Text));
        tmp := tmp + Length(Separator);
      end else
      begin
         Dest[tmp] := Text;
         Text := '';
      end;
	  until Length(Text)=0;
	end;


  //ConstList: list of constants
  //Replacements: list of replacements, in the same order as constants; both lists are strings,
  //              with elements separated by #1
  //Text: text to process
  // Example: ProcessConstants('{foo}'#1'{bar}','BAR'#1'FOOBAR','bla{foo}bla{bar}bla') would
  // return 'blaBARblaFOOBARbla'
  function ProcessConstants(ConstList, Replacements, Text: String): String;
  var	Consts, Replac: TArrayOfString;
  		i: Integer;
  begin
  	Explode(Consts,ConstList,#1);
  	Explode(Replac,Replacements,#1);
  	
 		Result := Text;
  	if GetArrayLength(Consts) <> GetArrayLength(Replac) then
  		exit;

  	for i := 0 to GetArrayLength(Consts) - 1 do
  		Result := Replace(Consts[i],Replac[i],Result);
  end;


  function GetText(ID: String): String;
  var LangFile: String;
  begin
  	LangFile := ExpandConstant('{tmp}\'+ActiveLanguage+'.isl+');

  	if not FileExists(LangFile) then
  		ExtractTemporaryFile(ActiveLanguage+'.isl+');

  	Result := GetIniString('Gimp',ID,'<"'+ID+'" missing from language file>',LangFile);
  	Result := Replace('%n',#13#10,Result);

  end;

  function GetCPU(): Word;
	var
  	SysInfo: TSystemInfo;
  begin
	  GetSystemInfo(SysInfo);
  	
		Result := SysInfo.wProcessorLevel;
	end;


  function InitializeSetup(): Boolean;
  var InstVers, SetupINI, S, S1, S2, PathDir, BadDLLList, GTKBinDir: String;
      i,j: Integer;
      PathDirs: TArrayOfString;
      GTKIds,GTKIDParams: TArrayOfString;
  begin

    Result := True;

    ShouldRenameBadDLLs := 0;
    Warnings := 0;

    If not RegQueryStringValue(HKLM, GTKRegPath, 'Path', GTKDir) then //find GTK+
      RegQueryStringValue(HKCU, GTKRegPath, 'Path', GTKDir);          //install dir
      
    If not RegQueryStringValue(HKLM, GTKRegPath, 'Version', InstVers) then //get installed GTK version (if any)
      RegQueryStringValue(HKCU, GTKRegPath, 'Version', InstVers);
      
    //try to get GTK uninstall key
    Explode(GTKIDs,GTKUninstKeys,'\');
    Explode(GTKIDParams,GTKUninstParams,'\');
    OldGTKUninstall := '';
    for i := 0 to GetArrayLength(GTKIDs) - 1 do
    	if RegQueryStringValue(HKLM, UninstPath + GTKIDs[i], 'UninstallString', OldGTKUninstall) then
    		break
    	else if RegQueryStringValue(HKCU, UninstPath + GTKIDs[i], 'UninstallString', OldGTKUninstall) then
    		break;
    if i < GetArrayLength(GTKIDParams) then
    	OldGTKUninstallParams := GTKIDParams[i];

    if (Length(OldGTKUninstall) > 0) and (OldGTKUninstall[1] = '"') then
      OldGTKUninstall := Copy(OldGTKUninstall,2,Length(OldGTKUninstall)-2);
      
    if (OldGTKUninstall = '') and (GTKDir <> '') then
      Warnings := Warnings or 65;

 		//used for bad DLL list
 		if not ExtractTemporaryFile('setup.ini') then
		begin
			MsgBox(GetText('ErrorExtractingTemp'),mbError,0);
			Result := False;
			exit;
		end;
		SetupINI := ExpandConstant('{tmp}\setup.ini');

    if InstVers>'{#= GTKVer}' then //newer version of GTK is already installed
    begin
      Warnings:=Warnings or 2;
      Warnings:=Warnings or 1;
    end

    (* //uninstalled now instead
    if (GTKDir <> '') and (InstVers<OldGTKVersion) then //older installer was used, which can't be automatically updated
    begin
      Warnings :=
    end;*)
    
    if RegValueExists(HKLM, GTKRegPath, 'Path') and (not IsAdminLoggedOn) then  //if GTK+ was installed by admin
    begin                                                          //previously, don't allow normal user to upgrade
      Warnings:=Warnings or 4;
      Warnings:=Warnings or 1;
    end

    If (not IsAdminLoggedOn) then
      Warnings:=Warnings or 8;

    If (GetCPU < 5) then
      Warnings := Warnings or 17;

    (*SetArrayLength(InstPath, 2);    //used for selecting installation path
    SetArrayLength(InstPathVal, 2);
    InstPath[0]:='&Default (recommended)';
    InstPath[1]:='&Custom (for advanced users)';
    InstPathVal[0]:='1';
    InstPathVal[1]:='0';*)
    
    //determine the subdirectory (bin or lib) used by GTK
    if GTKDir <> '' then
      if FileExists(GTKDir + '\bin\libgtk-win32-2.0-0.dll') then
        GTKBinDir := GTKDir + '\bin'
      else if FileExists(GTKDir + '\lib\libgtk-win32-2.0-0.dll') then
        GTKBinDir := GTKDir + '\lib';      	

		//get the "bad" dll list
    S := GetIniString('Setup','DLLList','<none>',SetupINI);
		Explode(BadDLLs, S, ',');

		PathDir := ExpandConstant('{sys}')+';'+ExpandConstant('{win}')+';'+ExpandConstant('{%PATH}');
		Explode(PathDirs, PathDir, ';');

		S := ''; //search PATH for these DLLs
		for i := 0 to GetArrayLength(PathDirs) - 1 do
		  //skip GTK's own install dir
			if ((GTKBinDir <> '') and (LowerCase(GetShortName(PathDirs[i])) <> LowerCase(GetShortName(GTKBinDir)))) or (GTKBinDir = '') then
				for j := 0 to GetArrayLength(BadDLLs) - 1 do
					if FileExists(AddBackslash(PathDirs[i])+BadDLLs[j]) then
						if Pos(BadDLLs[j],S) = 0 then
							S := S + AddBackslash(PathDirs[i])+BadDLLs[j] + ',';
		if Length(S) > 0 then
		begin
			S := Copy(S,1,Length(S)-1);
			Explode(BadDLLs, S, ',');
		end else
			SetArrayLength(BadDLLs,0);

		//format the text here; if I did it later, the delay becomes too obvious
    BadDLLList := '';
		for i := 0 to GetArrayLength(BadDLLs) - 1 do
			BadDLLList := BadDLLList + BadDLLs[i] + '//';
    BadDLLList := Copy(BadDLLList,1,Length(BadDLLList) - 2);
        
    BadDLLList := Replace('\','\\',BadDLLList);
    BadDLLList := Replace('//',RTFPara,BadDLLList);
    BadDLLList := '\pard\li284 ' + BadDLLList + '\sa60 ';

    S1 := '{p}'#1'{dlllist}'#1'{b}'#1'{/b}'#1'{i}'#1'{/i}';
    S2 := RTFPara+#1+BadDLLList+RTFPara+'\pard '#1'\b '#1'\b0 '#1'\i '#1'\i0 ';

		BadDLLText := RTFHeaderM + '\sa60';
 		S := GetText('DLLPageMessage');
 		BadDLLText := BadDLLText + ProcessConstants(S1,S2,S) + RTFPara;
 		BadDLLText := BadDLLText + #13#10'}';

    //install into default path when running silent
    if WizardSilent then
      if GTKDir = '' then
        GTKdir := ExpandConstant('{cf}\GTK\2.0');

    if GTKDir='' then
      DontChooseDir:=False  //choose GTK dir
    else
      DontChooseDir:=True; //use previous GTK dir
      
    #ifdef testing
    //Warnings := 65534;
    #endif

  end;


  function SkipCurPage(CurPage: Integer): Boolean;
  begin
    case CurPage of
      wpSelectDir:
      begin
        Result := DontChooseDir;
      end
      else
        Result := False;
    end;
  end;


  //GTK+ installation directory (can be called from script like this: {code:GetGTKDir|default} )
  function GetGTKDir(S: String): String;
  begin
    if GTKdir = '' then
      GTKDir := WizardDirValue;
    Result := GTKdir;
  end;


  procedure TerminateSetup(Sender: TObject);
  begin
    PostMessage(StrToInt(ExpandConstant('{wizardhwnd}')),WM_QUIT,0,0);
  end;


  procedure EnableNextButton(Sender: TObject);
  begin
    WizardForm.NextButton.Enabled := True;
  end;
  

  function ScriptDlgPages(CurPage: Integer; BackClicked: Boolean): Boolean;
  var Next: Boolean;
      //CurSubPage: Integer;
      Text: String;
  		RichEditViewer: TRichEditViewer;
  		rbYes, rbNo: TRadioButton;
  begin
  
    #ifdef testing
    WizardForm.Caption := 'Testing - Not for distribution!!!';
    #endif

    if (not BackClicked and (CurPage = wpWelcome)) or (BackClicked and (CurPage = wpLicense)) then
    begin
      //////////////////////////////////////////////
      // Errors (the installation can't continue) //
      //////////////////////////////////////////////
      If Warnings > 0 then begin //display the page only if necessary
        if (Warnings and 1)=1 then
        begin
	        ScriptDlgPageSetCaption(GetText('ProblemCaption2'));
  	      ScriptDlgPageSetSubCaption1(GetText('ProblemSubcaption2'));
        end else
        begin
	        ScriptDlgPageSetCaption(GetText('ProblemCaption1'));
  	      ScriptDlgPageSetSubCaption1(GetText('ProblemSubcaption1'));
        end;

        Text := RTFHeader;
        If (Warnings and 2)=2 then
          Text := Text+RTFBullet+GetText('ProblemNewer')+RTFPara;
        If (Warnings and 4)=4 then
          Text := Text+RTFBullet+GetText('ProblemPrevAdmin')+RTFPara;
        if (Warnings and 8)=8 then
          Text := Text+RTFBullet+GetText('ProblemAdmin')+RTFPara;
        if (Warnings and 16)=16 then
          Text := Text+RTFBullet+GetText('ProblemPentium')+RTFPara;
        if (Warnings and 32)=32 then
          Text := Text+RTFBullet+GetText('ProblemWin9xME')+RTFPara;
        if (Warnings and 64)=64 then
          Text := Text+RTFBullet+GetText('ProblemGTKCantUninstall')+RTFPara;

        Next := OutputMsg(Text,False);
        if (Warnings and 1)=1 then
        begin
          WizardForm.BackButton.Enabled := False;
          WizardForm.NextButton.Enabled := False;
          WizardForm.CancelButton.OnClick := @TerminateSetup;
          WizardForm.CancelButton.Caption := GetText('ButtonClose');
        end;

        Text := Text + '}';

        RichEditViewer := TRichEditViewer.Create(WizardForm.ScriptDlgPanel);
        with RichEditViewer do
        begin
          Parent := WizardForm.ScriptDlgPanel;
          Scrollbars := ssVertical;
          UseRichEdit := True;
          ReadOnly := True;
          Width := WizardForm.ScriptDlgPanel.Width;
          Height := WizardForm.ScriptDlgPanel.Height - 8;
        end;
        RichEditViewer.RTFText := Text;

        Next := ScriptDlgPageProcessCustom();

        if not BackClicked then
          Result := Next
        else
          Result := not Next;

        ScriptDlgPageClose(not Result);

      end else begin
        Result := True;
      end;

    end else if (not BackClicked and (CurPage = wpSelectComponents)) or (BackClicked and (CurPage = wpReady)) then
    begin

      //warn about Wimp and non-truetype fonts
      if (InstallOnThisVersion('4,4','0,4') = irInstall) and (ShouldProcessEntry('theme','') = srYes) then
     		MsgBox(GetText('WimpWin9x'),mbInformation,0);
     	
    	if GetArrayLength(BadDLLs) > 0 then
    	begin

    		WizardForm.Cursor := crHourglass;

        ScriptDlgPageOpen();
        ScriptDlgPageSetCaption(GetText('DLLPageCaption'));
        ScriptDlgPageSetSubCaption1(GetText('DLLPageSubcaption'));

        RichEditViewer := TRichEditViewer.Create(WizardForm.ScriptDlgPanel);
        with RichEditViewer do
        begin
          Parent := WizardForm.ScriptDlgPanel;
          Scrollbars := ssVertical;
          UseRichEdit := True;
          ReadOnly := True;
          Top := 0;
          Left := 0;
          Width := WizardForm.ScriptDlgPanel.Width;
          Height := WizardForm.LicenseMemo.Height + WizardForm.LicenseMemo.Top;
          RTFText := BadDLLText;
        end;

        rbYes := TRadioButton.Create(WizardForm.ScriptDlgPanel);
        with rbYes do
        begin
        	Parent := WizardForm.ScriptDlgPanel;
        	Left := WizardForm.LicenseAcceptedRadio.Left - WizardForm.ScriptDlgPanel.Left;
        	Width := WizardForm.ScriptDlgPanel.Width - Left;
        	Top := WizardForm.LicenseAcceptedRadio.Top - WizardForm.ScriptDlgPanel.Top;
        	Height := WizardForm.LicenseAcceptedRadio.Height;
        	Caption := GetText('DLLPageOptionRename');
        	OnClick := @EnableNextButton;
        	if ShouldRenameBadDLLs = 1 then
        		Checked := True;
        end;

        rbNo := TRadioButton.Create(WizardForm.ScriptDlgPanel);
        with rbNo do
        begin
        	Parent := WizardForm.ScriptDlgPanel;
        	Left := WizardForm.LicenseNotAcceptedRadio.Left - WizardForm.ScriptDlgPanel.Left;
        	Width := WizardForm.ScriptDlgPanel.Width - Left;
        	Top := WizardForm.LicenseNotAcceptedRadio.Top - WizardForm.ScriptDlgPanel.Top;
        	Height := WizardForm.LicenseNotAcceptedRadio.Height;
        	Caption := GetText('DLLPageOptionSkip');
        	OnClick := @EnableNextButton;
        	if ShouldRenameBadDLLs = 2 then
        		Checked := True;
        end;
        
       	if ShouldRenameBadDLLs = 0 then
	        WizardForm.NextButton.Enabled := False;

    		WizardForm.Cursor := crDefault;

       	Next := ScriptDlgPageProcessCustom();

       	if rbYes.Checked then
       		ShouldRenameBadDLLs := 1
       	else if rbNo.Checked then
					ShouldRenameBadDLLs := 2;

        if not BackClicked then
          Result := Next
        else
          Result := not Next;

        ScriptDlgPageClose(not Result);

    	end else
    	begin	
    		Result := True;
    	end;

    end else
    begin	
   		Result := True;
   	end;
  end;


  procedure TerminateSetup2;
  var cProcPid, cProcHandle: Cardinal;
  begin
    GetWindowThreadProcessId(StrToInt(ExpandConstant('{wizardhwnd}')), cProcPid);
    cProcHandle := OpenProcess(PROCESS_ALL_ACCESS,StrToInt(ExpandConstant('{wizardhwnd}')), cProcPid);
    TerminateProcess(cProcHandle,0);
  end;


  function ParseReadyMemoText(Spaces,Text: String): String;
  var t: String;
  begin
    t := Copy(Text,Pos(#10,Text)+1,Length(Text));
    t := Replace('\','\\',t);
    t := Replace(#13#10,'\par'#13#10,t);
    t := Replace(Spaces,'',t);
    Result := '\b ' + Copy(Text,1,Pos(#13,Text)-1) + '\par' +
              '\li284\b0 ' + t + '\par'#13#10'\pard\par'#13#10;
  end;


  function UpdateReadyMemo(Space, NewLine, MemoUserInfo, MemoDirInfo, MemoTypeInfo, MemoComponentsInfo, MemoGroupInfo, MemoTasksInfo: String): String;
  var S, T: String;
  begin

    (* redirect the ready memo information to the RTF viewer *)

    if DontChooseDir=True then
      T := '!TODO!GTK+ 2 was found in:' + NewLine + Space + GetGTKDir('')
    else
      T := '!TODO!Destination directory:' + NewLine + Space + GetGTKDir('');
      
    S := RTFHeaderM;
    S := S + ParseReadyMemoText(Space,T);
    S := S + ParseReadyMemoText(Space,MemoTypeInfo);
    S := S + ParseReadyMemoText(Space,MemoComponentsInfo);

    ReadyMemoRichText := S + '}';

    Result := 'If you see this, I screwed up';
  end;


  function NextButtonClick(CurPage: Integer): Boolean;
  begin
    Result := ScriptDlgPages(CurPage, False);
  end;


  function BackButtonClick(CurPage: Integer): Boolean;
  begin
    Result := ScriptDlgPages(CurPage, True);
  end;


  (* convert RGB color to BGR HEX value *)
  function RGBBGR(q: Integer): String;
  var a,b,c: String;
      d,e: Integer;
  begin

    while q>0 do
    begin
      e := (q and 15) + 1;
      a := copy('0123456789ABCDEF', e, 1);
      q := q / 16;
      c := a + b;
      b := c;
    end;

    d:=6-Length(b);
    if d>0 then
    begin
      c := StringOfChar('0',d) + b;
      b := c;
    end;

    a := copy(b,1,2);
    c := copy(b,5,2);
    b := copy(b,3,2);

    Result := c + b + a;
  end;

  procedure CurStepChanged(CurStep: Integer);
  var S,GTKRC: String;
      clBtnFace,clBtnShadow,clBtnLight,clText,clGrayText,clHilight,clHilightText,
      clTooltip,clTooltipText,clWindow,clWindowText: String;
      i: Integer;
  begin
    if curStep = csCopy then
      if OldGTKUninstall <> '' then
      begin
      
        WizardForm.StatusLabel.Caption := GetText('UninstallingOldGTK');

        if OldGTKUninstallParams = '' then
        	MsgBox(GetText('UninstallGTKManually'),mbInformation,0);
        
        if not InstExec(OldGTKUninstall,OldGTKUninstallParams,ExtractFilePath(OldGTKUninstall),True,False,0,i) then
        begin
          MsgBox(GetText('ErrorUninstallingOldGTK'),mbInformation,0);
          TerminateSetup2;
        end;
        
        Sleep(1000);

        //wait for the uninstaller to clean after itself
        if FileExists(OldGTKUninstall) then
        begin
        	for i := 0 to 20 do
        	begin
        		Sleep(250);
        		if not FileExists(OldGTKUninstall) then
        			break;
        	end;
        	if i > 20 then
        	begin
	          MsgBox(GetText('ErrorUninstallingOldGTK'),mbInformation,0);
  	        TerminateSetup2;
        	end;
        end;
          
      end;

  	if curStep = csFinished then
  	begin
  	
  	  //rename DLLs			
			if (ShouldRenameBadDLLs = 1) and (GetArrayLength(BadDLLs) > 0) then
			begin
 			  WizardForm.StatusLabel.Caption := GetText('RenamingFiles');
				for i := 0 to GetArrayLength(BadDLLs) - 1 do
				begin
  			  WizardForm.FileNameLabel.Caption := BadDLLs[i];
					if not RenameFile(BadDLLs[i],BadDLLs[i]+'.off') then
					  MsgBox(ProcessConstants('{dll}',BadDLLs[i],GetText('CouldNotRenameDLL')),mbInformation,0);
				end;
			end;

      if (ShouldProcessEntry('base','gtkrc')=srYes) then
      begin
        GTKRC := GTKdir + '\etc\gtk-2.0\gtkrc';

        if not FileExists(GTKRC) then //dummy file should be placed there by the installer
          MsgBox('Error: Windows color scheme could not be saved. (This should never happen)',mbInformation,0)
        else
        begin
        
          //get the windows' colors
          clBtnFace := RGBBGR(GetSysColor(15));
          clBtnShadow := RGBBGR(GetSysColor(16));
          clBtnLight := RGBBGR(GetSysColor(20));
          clText := RGBBGR(GetSysColor(18));
          clWindow := RGBBGR(GetSysColor(5));
          clWindowText := RGBBGR(GetSysColor(8));
          clGrayText := RGBBGR(GetSysColor(17));
          clHilight := RGBBGR(GetSysColor(13));
          clHilightText := RGBBGR(GetSysColor(14));
          clTooltip := RGBBGR(GetSysColor(24));
          clTooltipText := RGBBGR(GetSysColor(23));          
          
          S:='#generated by GTK+ 2 install';
          S:=S+#10;
          S:=S+#10'style "default"';
          S:=S+#10'{';
          S:=S+#10'  bg[NORMAL] = "#'+clBtnFace+'"';
          S:=S+#10'  bg[SELECTED] = "#'+clHilight+'"';
          S:=S+#10'  bg[INSENSITIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  bg[ACTIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  bg[PRELIGHT] = "#'+clHilight+'"';
          S:=S+#10'';
          S:=S+#10'  base[NORMAL] = "#'+clWindow+'"';
          S:=S+#10'  base[SELECTED] = "#'+clHilight+'"';
          S:=S+#10'  base[INSENSITIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  base[ACTIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  base[PRELIGHT] = "#'+clWindow+'"';
          S:=S+#10'';
          S:=S+#10'  text[NORMAL] = "#'+clWindowText+'"'; //clText
          S:=S+#10'  text[SELECTED] = "#'+clHilightText+'"';
          S:=S+#10'  text[INSENSITIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  text[ACTIVE] = "#'+clText+'"';
          S:=S+#10'  text[PRELIGHT] = "#'+clWindowText+'"'; //clHilightText
          S:=S+#10'';
          S:=S+#10'  fg[NORMAL] = "#'+clText+'"';
          S:=S+#10'  fg[SELECTED] = "#'+clHilightText+'"';
          S:=S+#10'  fg[INSENSITIVE] = "#'+clGrayText+'"';
          S:=S+#10'  fg[ACTIVE] = "#'+clText+'"';
          S:=S+#10'  fg[PRELIGHT] = "#'+clHilightText+'"';
          S:=S+#10'}';
          S:=S+#10'class "*" style "default"';
          S:=S+#10'';
          S:=S+#10'style "tooltip"';
          S:=S+#10'{';
          S:=S+#10'  bg[NORMAL] = "#'+clTooltip+'"';
          S:=S+#10'  fg[NORMAL] = "#'+clTooltipText+'"';
          S:=S+#10'}';
          S:=S+#10'widget "*gtk-tooltip*" style "tooltip"';
          S:=S+#10'';
          S:=S+#10'style "button" {';
          S:=S+#10'  bg[NORMAL]    = "#'+clBtnFace+'"';
          S:=S+#10'  bg[PRELIGHT]  = "#'+clBtnFace+'"';
          S:=S+#10'  bg[INSENSITIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  fg[PRELIGHT] = "#'+clText+'"';
          S:=S+#10'}';
          S:=S+#10'widget "*Gtk*Button*" style "button"';
          S:=S+#10'';
          S:=S+#10'style "text" {';
          S:=S+#10'  fg[NORMAL] = "#'+clWindowText+'"';
          S:=S+#10'}';
          S:=S+#10'widget_class "*Entry*" style "text"';
          S:=S+#10'widget_class "*Tree*" style "text"';
          S:=S+#10'widget_class "*Text*" style "text"';
          S:=S+#10'widget_class "*GtkSpinButton*" style "text"';
          S:=S+#10'widget_class "*Editable*" style "text"';
          S:=S+#10'widget_class "*Combo*" style "text"';
          S:=S+#10'';

          if not SaveStringToFile(GTKRC,S,False) then
            MsgBox('Error: could not update color scheme file.',mbInformation,0);

        end;
      end;
  	end;
  end;
  
  
  function AdminCheck(S: String): Boolean;
  begin
    if S='yes' then
    begin
      if IsAdminLoggedOn then
        Result:=True
      else
        Result:=False;
    end else
    begin
      if IsAdminLoggedOn then
        Result:=False
      else
        Result:=True;
    end;
  end;
  

  //ensure that GTK install directory isn't in PATH yet
  function PrevPathCheck(): Boolean;
  var S, autoexec: String;
      filecont: TArrayOfString;
      i: Integer;
  begin
    Result := False;
    
    if UsingWinNT then
    begin
    
      if RegQueryStringValue(HKLM, 'SYSTEM\CurrentControlSet\Control\Session Manager\Environment', 'Path', S) then
        if Pos(Lowercase(GTKdir+'\bin'), Lowercase(S)) = 0 then
          Result := True;
          
    end else
    begin

      //modify AUTOEXEC.BAT to add GTK+ install directory to PATH
    
      autoexec := ExpandConstant('{sd}\autoexec.bat');
      
      LoadStringsFromFile(autoexec, filecont);
      for i := 0 to GetArrayLength(filecont) - 1 do
      begin
        S := Lowercase(filecont[i]);

        if Pos('path=',S) > 0 then
        	if (Pos('path=',S) < Pos(Lowercase(GetShortName(GTKdir+'\bin')),S)) or (Pos('path=',S) < Pos(Lowercase(GTKdir+'\bin'),S)) then
        	begin
        		Result := True;
        		break;
        	end;
      end;

      if Result = False then
      begin

      	S := #13#10'SET PATH=%PATH%;' + Lowercase(GetShortName(GTKdir+'\bin')) + #13#10;
      	if not SaveStringToFile(autoexec, S, True) then
      		MsgBox('Error: Could not modify ' + Uppercase(autoexec),mbCriticalError,0);

      end;
      
      Result := False;

    end;
  end;


  procedure ComponentsListOnClick(Sender: TObject);
  var i: Integer;
  begin
    for i := 0 to 2 do
      if TNewCheckListBox(Sender).Selected[i] then
      begin
        case i of
        0: lblDescriptionText.Caption := GetText('ComponentsBaseDescription');
        1: lblDescriptionText.Caption := GetText('ComponentsWimpDescription');
        2: lblDescriptionText.Caption := GetText('ComponentsTranslationsDescription');
        end;
        exit;
      end;
  end;
  
  procedure CurPageChanged(CurPage: Integer);
  var NewReadyMemo: TRichEditViewer;
      pnlDescription: TPanel;
      lblDescription: TNewStaticText;
  begin
    case curPage of
    wpSelectComponents:
      begin
      	if WizardForm.ComponentsList.Width = WizardForm.ScriptDlgPanel.Width then
	        WizardForm.ComponentsList.Width := Round(WizardForm.ComponentsList.Width * 0.6);
        
        WizardForm.ComponentsList.OnClick := @ComponentsListOnClick;
        
        pnlDescription := TPanel.Create(WizardForm.ComponentsList.Parent);
        with pnlDescription do
        begin
          Parent := WizardForm.ComponentsList.Parent;
          Left := WizardForm.ComponentsList.Left + WizardForm.ComponentsList.Width + 8;
          Width := WizardForm.TypesCombo.Width - WizardForm.ComponentsList.Width - 8;
          BevelOuter := bvLowered;
          BevelInner := bvRaised;
          Top := WizardForm.ComponentsList.Top + 5;
          Height := WizardForm.ComponentsList.Height - 5;
        end;
        
        lblDescription := TNewStaticText.Create(WizardForm.ComponentsList.Parent)
        with lblDescription do
        begin
          Parent := WizardForm.ComponentsList.Parent;
          Left := pnlDescription.Left + 8;
          Top := WizardForm.ComponentsList.Top;
          AutoSize := True;
          Caption := GetText('ComponentsDescription');
        end;
        
        lblDescriptionText := TLabel.Create(pnlDescription);
        with lblDescriptionText do
        begin
          Parent := pnlDescription;
          Left := 8;
          WordWrap := True;
          AutoSize := False;
          Width := Parent.Width - 16;
          Height := Parent.Height - 20;
          Top := 12;
        end;
        
      end;
    wpReady:
      begin
        WizardForm.ReadyMemo.Visible := False;
      
        NewReadyMemo := TRichEditViewer.Create(WizardForm.ReadyMemo.Parent);
        NewReadyMemo.Parent := WizardForm.ReadyMemo.Parent;//WizardForm.ScriptDlgPanel
        NewReadyMemo.Scrollbars := ssVertical;
        NewReadyMemo.Color := WizardForm.Color;
        NewReadyMemo.UseRichEdit := True;
        NewReadyMemo.RTFText := ReadyMemoRichText;
        NewReadyMemo.ReadOnly := True;
        NewReadyMemo.Left := WizardForm.ReadyMemo.Left;
        NewReadyMemo.Top := WizardForm.ReadyMemo.Top;
        NewReadyMemo.Width := WizardForm.ReadyMemo.Width;
        NewReadyMemo.Height := WizardForm.ReadyMemo.Height;
        NewReadyMemo.Visible := True;
      
        {NewReadyMemo.Width := WizardForm.ScriptDlgPanel.Width;
        NewReadyMemo.Height := WizardForm.ScriptDlgPanel.Height;}
      end;
    end;
  end;

begin
end.
